;####################################################
; WoodStock Logo v.1.0 : Menus & Functions
;####################################################
; Informatik 1A: Projekt
;----------------------------------------------------
; BROCCO Amos
; BALABBIO Mara
; STOJANOVIC Tanja
;####################################################

(define action_list '())
(load "ex-def.scm")


(define (seticon unaframe)
 (let* ((bitmap_icona (make-object bitmap% 16 16 #f))
      (Setta (send bitmap_icona load-file "icona.jpg" 'jpeg)))
      (send unaframe set-icon bitmap_icona #f 'both)))

(define (setup-graphics-menu theMenubar)
  (let* ((theMenu (make-object menu% "Graphics" theMenubar)))
    (make-object menu-item% "Clear Graphics screen" theMenu clearscreen-proc)
    (make-object menu-item% "Refresh" theMenu recalculate-proc)
    (make-object separator-menu-item% theMenu)
    (let* ((theSamples (make-object menu% "Samples" theMenu)))
      (make-object menu-item% "Koch Triangle" theSamples kochtriangle-proc)
      (make-object menu-item% "Treppe" theSamples Treppe-proc)
      (make-object menu-item% "MoveOnLine" theSamples MoveOnLine-proc)
      (make-object menu-item% "MoveOnCircle" theSamples MoveOnCircle-proc)
     (make-object menu-item% "Hilbert Curve" theSamples Hilbert-proc)
      (make-object menu-item% "Dragon" theSamples dragon-proc)
      (make-object menu-item% "Pine Tree" theSamples Pinetree-proc)
      (make-object menu-item% "XMas Tree" theSamples xmastree-proc)
      (make-object menu-item% "Olympia" theSamples olympia-proc)
      (make-object menu-item% "Farn" theSamples ramo-proc)
    (make-object menu-item% "Flower" theSamples Flower-proc))
    (let ((assi (make-object checkable-menu-item% "Axes" theMenu axes-proc)))
      (send assi check axes?))))

(define (setup-evaluation-menu theMenubar)
  (let ((theMenu (make-object menu% "Evaluation" theMenubar)))
    (make-object menu-item% "Eval Selection" theMenu eval-selection-proc)
    (make-object menu-item% "Eval Window" theMenu eval-window-proc)))

(define (setup-transcript-eval-menu theMenubar)
  (let ((theMenu (make-object menu% "Evaluation" theMenubar)))
    (make-object menu-item% "Eval Selection" theMenu eval-selection-proc)
    (make-object separator-menu-item% theMenu)
    (make-object menu-item% "Break" theMenu break-proc)))

(define (setup-cmd-panel theFrame)
(let ((panel (make-object horizontal-panel% theFrame (list 'border))))
(make-object button% "Eval Select&ion" panel
  (lambda (button event)(eval-selection-proc 0 0)))
(make-object button% "Eval Wi&ndow" panel
  (lambda (button event)(eval-window-proc 0 0)))
(send panel stretchable-height #f)
(send panel stretchable-width #t)  
  (send panel set-alignment 'right 'bottom )
  ))

(define (setup-transcript-panel theFrame)
(let ((panel (make-object horizontal-panel% theFrame (list 'border))))
  
 (let ((debug-panel (make-object horizontal-panel% panel (list 'border))))
(make-object button% "Brea&k" debug-panel
  (lambda (button event)(break-proc 0 0)))
(let ((debug (make-object check-box% "Allow Break" debug-panel with-debugging-proc)))
      (send debug set-value with_debugging?))
   (let ((log (make-object check-box% "Eval Log" debug-panel eval-log-proc)))
      (send log set-value show_log?))
   (send debug-panel stretchable-height #f)
(send debug-panel stretchable-width #t)  
  (send panel set-alignment 'left 'center ))
     
(make-object button% "&Recalculate" panel
  (lambda (button event)(recalculate-proc 0 0)))
(make-object button% "Eval Select&ion" panel
  (lambda (button event)(eval-selection-proc 0 0)))
(make-object button% "Environment Reset" panel
  (lambda (button event)(reset-proc 0 0)))
(send panel stretchable-height #f)
(send panel stretchable-width #t)  
  (send panel set-alignment 'right 'center )
  ))

(define (setup-environment-menu theMenubar)
  (let ((theMenu (make-object menu% "Environment" theMenubar)))
    (make-object menu-item% "Environment Reset" theMenu reset-proc)
    (make-object separator-menu-item% theMenu)
    (let* ((theActions (make-object menu% "Actions history" theMenu)))
    (make-object menu-item% "Recalculate" theActions recalculate-proc)
    (make-object separator-menu-item% theActions)
    (make-object menu-item% "Insert all actions" theActions insert-allactions-proc)
    (make-object menu-item% "Insert transcript actions" theActions insert-transactions-proc)
    (make-object separator-menu-item% theActions)
    (make-object menu-item% "Clear transcript actions" theActions clear-transactions-proc)
    (make-object menu-item% "Clear all actions" theActions clear-allactions-proc))  
    (make-object separator-menu-item% theMenu)
    (make-object menu-item% "Clear text in window" theMenu cleartext-proc) 
    ))

(define (restore-windows-proc MItem CEvent)
(send GfxWindow show #t)
(send TranscriptWindow show #t))

(define (axes-proc MItem CEvent)
(if axes?
(begin
 (set! axes? #f)
  (send MItem check axes?) 
 (send GfxWindow refresh))
(begin
 (set! axes? #t)
 (send MItem check axes?)
 (draw-the-axes GfxCanvas))))


(define (with-debugging-proc CItem CEvent)
(if with_debugging?
(begin
 (set! with_debugging? #f)
  (send CItem set-value with_debugging?))
(begin
 (set! with_debugging? #t)
 (send CItem set-value with_debugging?))
 ))


(define (eval-log-proc CItem CEvent)
(if show_log?
(begin
 (set! show_log? #f)
  (send CItem set-value show_log?))
(begin
 (set! show_log? #t)
 (send CItem set-value show_log?))
 ))

  

(define (add-menus theFrame)
  (let ((theMenubar (send theFrame get-menu-bar)))
    (setup-font-menu theMenubar)
    (setup-evaluation-menu theMenubar)
    (setup-environment-menu theMenubar)
    (frame:reorder-menus theFrame)
    (seticon theFrame)))

(define (add-ts-menus theFrame)
  (let ((theMenubar (send theFrame get-menu-bar)))
    (setup-font-menu theMenubar)
    (setup-transcript-eval-menu theMenubar)
    (setup-environment-menu theMenubar)
    (frame:reorder-menus theFrame)
    (seticon theFrame)))

(define (add-menus-gfx theFrame)
  (let ((theMenubar (send theFrame get-menu-bar)))
    (setup-graphics-menu theMenubar)
    (frame:reorder-menus theFrame)
    (seticon theFrame)))

(define (setup-font-menu theMenubar)
  (let ((theMenu (make-object menu% "Font" theMenubar)))
  (append-editor-font-menu-items theMenu)))

(define (eval-selection-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
 (let ((theWindow (get-top-level-focus-window)))
          (let* ((ed (send theWindow get-editor))
                 (start (send ed get-start-position))
                 (end (send ed get-end-position))
                 (theText (send ed get-text start end #f #f)))
            (unless (= (string-length theText) 0)
              (if (scheme-paren:balanced? ed start end)
                  (let ((theList (extended-read theText)))
                    (evaluating)
                    (set! break? #f)
                    (newline)
                    (delta-print (myeval (cons 'begin theList) the-global-environment) result-delta)
                    (set! action_list theList)
                    (newline)
                    (delta-print "DONE : Eval Selection" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt))
                  (print-error-msg "unmatched parenthesis")))))))



(define (eval-window-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
      (let ((theWindow (get-top-level-focus-window)))
        (unless (eq? theWindow TranscriptWindow)
          (let* ((ed (send theWindow get-editor))
                 (start 0)
                 (theText (send ed get-text 0 'eof #f #f))
                 (end (string-length theText)))
            (unless (= (string-length theText) 0)
              (if (scheme-paren:balanced? ed start end)
                  (let ((theList (extended-read theText)))
                    (evaluating)
                    (set! break? #f)
                    (newline)
                    (delta-print (myeval (cons 'begin theList) the-global-environment) result-delta)
                    (set! action_list theList)
                    (newline)
                    (delta-print "DONE : Eval Window" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)
                    )
                  (print-error-msg "unmatched parenthesis"))))))))

(define (recalculate-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
                    (evaluating)
                    (set! break? #f)
                    (if (not (and (eq? action_list '()) (eq? t_action_list '())))
                    (begin
                    (newline)
                    (delta-print (myeval (cons 'begin (append action_list t_action_list)) the-global-environment) result-delta)))
                    (newline)
                    (delta-print "DONE : Recalculate" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)
                  ))

(define (insert-transactions-proc MItem CEvent)
(with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
 (let ((theWindow (get-top-level-focus-window)))
          (let* ((ed (send theWindow get-editor)))
            (if (not (eq? t_action_list '()))
                 (send ed insert (converttostring (cons 'begin t_action_list) 0)))
                  (send GfxWindow set-status-text "Inserting transcript actions...")
                    (newline)
                    (delta-print "DONE : Insert transcript actions" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)))
                  ))


(define (insert-allactions-proc MItem CEvent)
(with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
 (let ((theWindow (get-top-level-focus-window)))
          (let* ((ed (send theWindow get-editor)))
            (if (not (and (eq? t_action_list '())(eq? action_list '())))
                 (send ed insert (converttostring (cons 'begin (append action_list t_action_list)) 0)))
                  (send GfxWindow set-status-text "Inserting all actions...")
                    (newline)
                    (delta-print "DONE : Insert all actions" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)))
                  ))

(define (clear-allactions-proc MItem CEvent)
  (send GfxWindow set-status-text "Clearing all actions...")
   (set! action_list '())
  (set! t_action_list '())
  (newline)
  (delta-print "DONE : Clearing all actions" output-delta)
  (set-ts-status)
  (not-running)
  (transcript_prompt))

(define (clear-transactions-proc MItem CEvent)
  (send GfxWindow set-status-text "Clearing transcript actions...")
  (set! t_action_list '())
  (newline)
  (delta-print "DONE : Clearing transcript actions" output-delta)
  (not-running)
  (set-ts-status)
  (transcript_prompt))
        
(define (reset-proc MItem CEvent)
   (set! break? #f)
   (send (send GfxCanvas get-dc) clear)
   (send (ivar GfxCanvas back-dc) clear)
   (draw-the-axes GfxCanvas)
   (setup-global-environment)
   (send TranscriptEditor erase)
   (transcript_welcome)
   (newline)
   (delta-print "DONE: Reset" output-delta)
   (set! lastinput 0)
   (set! t_action_list '())
   (set! action_list '())
   (set-ts-status)  
   (transcript_prompt))

(define (break-proc MItem CEvent)
  (if with_debugging? (set! break? #t) (set! break? #f)) 
  )
 
(define (clearscreen-proc MItem CEvent)
  (send (send GfxCanvas get-dc) clear)
  (send (ivar GfxCanvas back-dc) clear)
  (draw-the-axes GfxCanvas)
  (newline)
  (delta-print "DONE: Clear Graphics screen" output-delta)
  (set-ts-status)
  (transcript_prompt))

(define (cleartext-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
 (let ((theWindow (get-top-level-focus-window)))
    (let* ((ed (send theWindow get-editor)))
            (send ed erase)
            (newline)
            (delta-print "DONE: Clear text in window" output-delta)
            (set-ts-status)
            (transcript_prompt)))))

;;; Sezione ESEMPI
(define (KochTriangle-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
                    (send GfxWindow set-status-text "Evaluating...")
                    (set! break? #f)
                    (myeval KochTriangle the-global-environment)
                    (newline)
                    (delta-print "DONE : Drawing KochTriangle Sample" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)))

(define (Treppe-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
                    (send GfxWindow set-status-text "Evaluating...")
                    (set! break? #f)
                    (myeval Treppe the-global-environment)
                    (newline)
                    (delta-print "DONE : Drawing Treppe Sample" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)))
                  

(define (MoveOnLine-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
                    (send GfxWindow set-status-text "Evaluating...")
                    (set! break? #f)
                    (myeval MoveOnLine the-global-environment)
                    (newline)
                    (delta-print "DONE : Drawing MoveOnLine Sample" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)))


(define (MoveOnCircle-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
                    (send GfxWindow set-status-text "Evaluating...")
                    (set! break? #f)
                    (myeval MoveOnCircle the-global-environment)
                    (newline)
                    (delta-print "DONE : Drawing MoveOnCircle Sample" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)))

(define (Olympia-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
                    (send GfxWindow set-status-text "Evaluating...")
                    (set! break? #f)
                    (myeval Olympia the-global-environment)
                    (newline)
                    (delta-print "DONE : Drawing Olympia Sample" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)))

(define (Flower-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
                    (send GfxWindow set-status-text "Evaluating...")
                    (set! break? #f)
                    (myeval Flower the-global-environment)
                    (newline)
                    (delta-print "DONE : Drawing Flower Sample" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)))

(define (Hilbert-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
                    (send GfxWindow set-status-text "Evaluating...")
                    (set! break? #f)
                    (myeval hilbert the-global-environment)
                    (newline)
                    (delta-print "DONE : Drawing Hilbert Curve Sample" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)))

(define (dragon-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
                    (send GfxWindow set-status-text "Evaluating...")
                    (set! break? #f)
                    (myeval dragon the-global-environment)
                    (newline)
                    (delta-print "DONE : Drawing Dragon Sample" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)))

(define (XMastree-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
                    (send GfxWindow set-status-text "Evaluating...")
                    (set! break? #f)
                    (myeval Xmastree the-global-environment)
                    (newline)
                    (delta-print "DONE : Drawing XMas Tree Sample" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)))

(define (pinetree-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
                    (send GfxWindow set-status-text "Evaluating...")
                    (set! break? #f)
                    (myeval pinetree the-global-environment)
                    (newline)
                    (delta-print "DONE : Drawing Pine Tree Sample" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)))


(define (ramo-proc MItem CEvent)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
                    (send GfxWindow set-status-text "Evaluating...")
                    (set! break? #f)
                    (myeval ramo the-global-environment)
                    (newline)
                    (delta-print "DONE : Drawing Farn Sample" output-delta)
                    (not-running)
                    (set-ts-status)
                    (transcript_prompt)))
                  
                  
                 
  



