;####################################################
; WoodStock Logo v.1.0 : MetaEValuator v.90
;####################################################
; Informatik 1A: Projekt
;----------------------------------------------------
; BROCCO Amos
; BALABBIO Mara
; STOJANOVIC Tanja
;####################################################

;====================================================
; DEFINIZIONI NECESSARIE AL FUNZIONAMENTO
;----------------------------------------------------

(define apply-in-underlying-scheme apply)
(define true #t)
(define false #f)
(define (atom? x) (not (pair? x)))
(define (true? x)
  (not (eq? x false)))
(define (false? x)
  (eq? x false))
;____________________________________________________


;====================================================
; FUNZIONE PRINCIPALE CHE GESTISCE LA TARTARUGA
;----------------------------------------------------
(define (my-draw-text text x y)
(send (send GfxCanvas get-dc) draw-text text (+ base-x x) (+ base-y y))'done)


(define (clearscreen)
  (send (send GfxCanvas get-dc) clear)
  (send (ivar GfxCanvas back-dc) clear)
  (draw-the-axes GfxCanvas)'done)

(define pi (acos -1))

;;; Funzione per convertire angolo da gradi a radianti
(define (torad angle)
    (* angle (/ pi 180)))   

(define (maketurtle)
  (let* (
        (t-X 0)
        (t-Y 0)
        (t-angle 0)
        (TurtleStack '())
        (disp? #f)
        (ispendown? #f)
        (TurtleColor "black")
        (TurtleWidth 1)
        (TurtleStyle 'solid)
        )

    
;;;**************** DISEGNO *************************
    
(define defaultpen (make-object pen% "black" 0 'solid))    



(define (rotate-x theta x y)
  (+ (* x (cos theta)) (* y (sin theta))))

(define (rotate-y theta x y)
  (- (* y (cos theta)) (* x (sin theta))))

(define (draw-triangle posX posY pen)
  (let ((p1a-x (+ posX (rotate-x (torad t-angle) 12 0)))
        (p1a-y (+ posY (rotate-y (torad t-angle) 12 0)))
        (p2a-x (+ posX (rotate-x (torad t-angle) -6 -7)))
        (p2a-y (+ posY (rotate-y (torad t-angle) -6 -7)))
        (p3a-x (+ posX (rotate-x (torad t-angle) -6 7)))
        (p3a-y (+ posY (rotate-y (torad t-angle) -6 7))))
        (draw-line p1a-x p1a-y p2a-x p2a-y pen)
        (draw-line p2a-x p2a-y p3a-x p3a-y pen)
        (draw-line p3a-x p3a-y p1a-x p1a-y pen)
      ))
    
(define (draw-turtle)
  (if disp?
      (let ((penturtle (make-object pen% "black" 0.0 'solid)))
      (draw-triangle t-X t-Y penturtle))))
    
(define (erase-turtle)
  (if disp?
      (let* ((dc (send GfxCanvas get-dc))
        (back-dc (ivar GfxCanvas back-dc))
        (original-pen (send dc get-pen))
        (background-pen (make-object pen% (send dc get-background) 0.0 'solid)))
        ;;;(send dc set-pen background-pen)
        ;;;(send back-dc set-pen background-pen)
        (draw-triangle t-X t-Y background-pen)
        (send dc set-pen original-pen)
        (send back-dc set-pen original-pen))))
 
    
;;;**************** COMANDI ***********************
    
(define (showturtle)
  (set! disp? #t)
  (draw-turtle))
  
(define (hideturtle)
  (erase-turtle)
  (set! disp? #f)
  )

(define (pendown)
  (set! ispendown? #t))

(define (penup)
  (set! ispendown? #f))

(define (setpencolor color)
  (set! TurtleColor color))
    
(define (setpenwidth width)
  (set! TurtleWidth width))
    
(define (setpenstyle style)
  (set! TurtleStyle style))
    
(define (forward distance)
  (let ((new-X (+ t-X (* distance (cos (torad t-angle)))))
        (new-Y (- t-Y (* distance (sin (torad t-angle)))))
        (tela (send GfxCanvas get-dc))
        (penna (make-object pen% TurtleColor TurtleWidth TurtleStyle)))
    (erase-turtle)
    (if (eq? ispendown? #t)
        (draw-line t-X t-Y new-X new-Y penna))
    (set! t-X new-X)
    (set! t-Y new-Y)
    (draw-turtle)))

(define (back distance)
  (forward (- distance)))
    
(define (easyangle)
  (let* ((quanto (quotient (floor t-angle) 360))
        (decremento (* quanto 360)))
    (set! t-angle (- t-angle decremento))))

(define (left theta)
  (erase-turtle)
  (set! t-angle (+ t-angle theta))
  (easyangle)
  (draw-turtle))

(define (right theta)
  (left (- theta)))

(define (setpos new-X new-Y)
  (erase-turtle)
  (set! t-X new-X)
  (set! t-Y new-Y)
  (draw-turtle)) 
    
(define (setangle newAngle)
  (erase-turtle)
  (set! t-angle newAngle)
  (easyangle)
  (draw-turtle))

(define (pushturtle)
   (set! TurtleStack (cons (list t-X t-Y t-angle) TurtleStack )))

(define (popturtle)
  (if (null? TurtleStack) (error "Stack Empty!")
  (begin
    (setpos (car (car TurtleStack)) (cadr (car TurtleStack)))
    (setangle (caddr (car TurtleStack))) 
    (set! TurtleStack (cdr TurtleStack)))))
          
(define (gohome)
  (begin
  (setpos 0 0)
  (setangle 0)
    ))

;;;**************** DISPATCH ************************

(define (dispatch request)
  (cond ((eq? request 'forward) forward)
        ((eq? request 'back) back)
        ((eq? request 'left) left)
        ((eq? request 'right) right)
        ((eq? request 'pendown) pendown)
        ((eq? request 'penup) penup)
        ((eq? request 'pushturtle) pushturtle)
        ((eq? request 'popturtle) popturtle)
        ((eq? request 'showturtle) showturtle)
        ((eq? request 'hideturtle) hideturtle)
        ((eq? request 'setpos) setpos)
        ((eq? request 'setangle) setangle)
        ((eq? request 'info) (list 'X: t-X 'Y: t-Y 'Angle: t-angle 'Color: TurtleColor 'Width: TurtleWidth 'Style: TurtleStyle 'Showturtle? disp? 'Pendown? ispendown?))
        ((eq? request 'setpencolor) setpencolor)
        ((eq? request 'setpenwidth) setpenwidth)
        ((eq? request 'setpenstyle) setpenstyle)
        ((eq? request 'gohome) gohome)
        (else (error "Unknown request -- TURTLE   " request))))
    dispatch))
;____________________________________________________


;====================================================
; METAEVALUATOR V.90 10.05.2001 - 12:00
;----------------------------------------------------

(define (myeval exp env)
(begin 
(if show_log? (begin (newline)(color-print (string-append "Evaluating: " (converttostring exp 1)) "silver")))
(if with_debugging? 
    (yield)
    (set! break? #f))
(if (eq? break? #f)
(cond   ((self-evaluating? exp) exp)
        ((variable? exp) (lookup-variable-value exp env))
        ((quoted? exp) (text-of-quotation exp))
        ((assignment? exp) (eval-assignment exp env))
        ((definition? exp) (eval-definition exp env))
        ((if? exp) (eval-if exp env))
        ((lambda? exp)
         (make-procedure (lambda-parameters exp)
                         (lambda-body exp)
                         env))
        ((?++ exp) (++-eval exp env))
        ((?-- exp) (---eval exp env))
        ((?+= exp) (+=-eval exp env))
        ((?-= exp) (-=-eval exp env))
        ((?*= exp) (*=-eval exp env))
        ((?/= exp) (/=-eval exp env))
        ((let*? exp) (myeval (let*->lets-nidificati exp) env))
        ((let? exp) (myeval (let->lambda exp) env))
        ((and? exp) (eval-and exp env))
        ((or? exp) (eval-or exp env))
        ((do? exp) 
         (eval-do exp env))
        ((while? exp) 
         (eval-while exp env))
        ((for? exp) 
         (eval-for exp env))
        ((repeat? exp) 
         (eval-repeat exp env))
        ((make-turtle? exp) (eval-make-turtle exp env))
        ((begin? exp) 
         (eval-sequence (begin-actions exp) env))
        ((cond? exp) (myeval (cond->if exp) env))
        ((application? exp)
         (myapply (myeval (operator exp) env)
                (list-of-values (operands exp) env)))
        (else
         (error "Unknown expression type -- EVAL" exp)))
(error "User Break!")
  )))
;____________________________________________________


;====================================================
; PRIMITIVE DI 'TRADUZIONE' PER TARTARUGA
;----------------------------------------------------

(define (showturtle tartaruga)
  ((tartaruga 'showturtle))'ok)

(define (hideturtle tartaruga)
  ((tartaruga 'hideturtle))'ok)

(define (pendown tartaruga)
  ((tartaruga 'pendown))'ok)

(define (penup tartaruga)
  ((tartaruga 'penup))'ok)

(define (pushturtle tartaruga)
  ((tartaruga 'pushturtle))'ok)

(define (popturtle tartaruga)
  ((tartaruga 'popturtle))'ok)

(define (info tartaruga)
  (tartaruga 'info))

(define (gohome tartaruga)
  ((tartaruga 'gohome))'ok)

(define (left tartaruga valore)
  ((tartaruga 'left) valore)'ok)

(define (right tartaruga valore)
  ((tartaruga 'right) valore)'ok)

(define (setangle tartaruga valore)
  ((tartaruga 'setangle) valore)'ok)

(define (forward tartaruga valore)
  ((tartaruga 'forward) valore)'ok)

(define (back tartaruga valore)
  ((tartaruga 'back) valore)'ok)

(define (setpos tartaruga valore1 valore2)
  ((tartaruga 'setpos) valore1 valore2)'ok)

(define (setpencolor tartaruga valore1)
  ((tartaruga 'setpencolor) valore1)'ok)

(define (setpenwidth tartaruga valore1)
  ((tartaruga 'setpenwidth) valore1)'ok)

(define (setpenstyle tartaruga valore1)
  ((tartaruga 'setpenstyle) valore1)'ok)
;____________________________________________________


;====================================================
; MYAPPLY
;----------------------------------------------------

(define (myapply procedure arguments)
   (cond ((primitive-procedure? procedure)
         (apply-primitive-procedure procedure arguments))
        ((compound-procedure? procedure)
         (eval-sequence
           (procedure-body procedure)
           (extend-environment
             (procedure-parameters procedure)
             arguments
             (procedure-environment procedure))))
        (else 
         (error
         "Unknown procedure type -- APPLY" procedure arguments))))
;____________________________________________________
  

;====================================================
; FUNZIONI DI VALUTAZIONE DEI COSTRUTTI
;----------------------------------------------------

(define (eval-make-turtle exp env)
  (define-variable! (if (null? (cdr exp))
                            (car exp)
                            (cadr exp))
                        (maketurtle)
                        env)
  (list 'A 'turtle 'named (cadr exp) 'is 'born!))

(define (list-of-values exps env)
  (if (no-operands? exps)
      '()
      (cons (myeval (first-operand exps) env)
            (list-of-values (rest-operands exps) env))))

(define (eval-if exp env)
  (if (true? (myeval (if-predicate exp) env))
      (myeval (if-consequent exp) env)
      (myeval (if-alternative exp) env)))

(define (eval-sequence exps env)
  (cond ((last-exp? exps) (myeval (first-exp exps) env))
        (else (myeval (first-exp exps) env)
              (eval-sequence (rest-exps exps) env))))

(define (eval-assignment exp env)
  (set-variable-value! (assignment-variable exp)
                       (myeval (assignment-value exp) env)
                       env))

(define (eval-definition exp env)
  (define-variable! (definition-variable exp)
                    (myeval (definition-value exp) env)
                    env)(definition-variable exp))
;____________________________________________________


;====================================================
; RICONOSCIMENTO TIPO FUNZIONI & COMPANY
;----------------------------------------------------

(define (application? exp) (pair? exp))
(define (operator exp) (car exp))
(define (operands exp) (cdr exp))

(define (no-operands? ops) (null? ops))
(define (first-operand ops) (car ops))
(define (rest-operands ops) (cdr ops))

(define (make-turtle? exp)
  (tagged-list? exp 'maketurtle))

(define (self-evaluating? exp)
  (cond ((number? exp) true)
        ((string? exp) true)
        (else false)))

(define (quoted? exp)
  (tagged-list? exp 'quote))

(define (text-of-quotation exp) (cadr exp))

(define (tagged-list? exp tag)
  (if (pair? exp)
      (eq? (car exp) tag)
      false))

(define (variable? exp) (symbol? exp))


(define (assignment? exp)

(tagged-list? exp 'set!))

(define (assignment-variable exp) (cadr exp))


(define (assignment-value exp) (caddr exp))

(define (definition? exp)
  (tagged-list? exp 'define))

(define (definition-variable exp)
  (if (symbol? (cadr exp))
      (cadr exp)
      (caadr exp)))

(define (definition-value exp)
  (if (symbol? (cadr exp))
      (caddr exp)
      (make-lambda (cdadr exp)
                   (cddr exp))))

(define (lambda? exp) (tagged-list? exp 'lambda))

(define (lambda-parameters exp) (cadr exp))
(define (lambda-body exp) (cddr exp))

(define (make-lambda parameters body)
  (cons 'lambda (cons parameters body)))
;____________________________________________________


;====================================================
; FUNZIONI SPECIALI CON 'RICONOSCITORI'
;----------------------------------------------------

;;;**************** EVAL - DO ***********************

(define (do? exp) (tagged-list? exp 'do))

(define (eval-do exp env)
  (let ((test (car (reverse exp)))
        (azioni (make-begin (cdr (reverse (cddr (reverse exp)))))))
  (myeval azioni env)
  (do-iter test azioni env)))

   (define (do-iter tester actions env)
         (if (eq? (myeval tester env) #f)
             (begin
             (myeval actions env)
             (do-iter tester actions env))))
              
        
  
  
;;;**************** EVAL - WHILE ********************

(define (while? exp) (tagged-list? exp 'while))

(define (eval-while exp env)
     (while-iter (make-begin (cddr exp)) (cadr exp) env))
       
       (define (while-iter what test env)
          (if (eq? (myeval test env) #t)
              (begin
              (myeval what env)
              (while-iter what test env)))
         )
          
       
      

;;;**************** EVAL - FOR **********************

(define (for? exp) (tagged-list? exp 'for))

(define (eval-for exp env)
  (begin
  ;;; Creiamo la variabile var e la definiamo al valore iniziale
  (eval-definition (list 'define (cadr exp) (cadddr exp)) env)
  (for-iter (cadr exp)
            (list '> (cadr exp) (car (cdddr (cddr  exp))))
            (list '++ (cadr exp))
            (cons 'begin (cdddr (cdddr exp))) env)))
  

  (define (for-iter variable tester to_increment to_do env)
      (if (eq? (myeval tester env) #f)
          (begin
            (myeval to_do env)
            (myeval to_increment env)
            (for-iter variable tester to_increment to_do env))))
      



;;;**************** EVAL - AND **********************

(define (and? exp) (tagged-list? exp 'and))

(define (eval-and exp env) 
   ;  una stringa nulla, se no...
   (if (null? exp) #t
     ;... comincia per and, se si rivaluta senza and
     (if (and? exp) 
         ;s  rivaluta senza and
         (eval-and (cdr exp) env) 
         ; se no valuta normalmente, se la valutazione  falsa
         ; tutto  falso
        (if (false? (myeval (car exp) env)) #f
          ; altrimenti valuta prossimo argomento
          (eval-and (cdr exp) env)))))



      
;;;**************** EVAL - OR ***********************

(define (or? exp) (tagged-list? exp 'or))


(define (eval-or exp env)

(if (null? (cdr exp)) #t
    (eval-or-iter exp env)))
 
(define (eval-or-iter exp env) 
   ;  una stringa nulla, se no...
   (if (null? exp) #f
     ;... comincia per and, se si rivaluta senza or
     (if (or? exp) 
         ;s  rivaluta senza or
         (eval-or-iter (cdr exp) env) 
         ; se no valuta normalmente, se la valutazione  vera
         ; tutto  vero
        (if (true? (myeval (car exp) env)) #t
          ; altrimenti valuta prossimo argomento
          (eval-or-iter (cdr exp) env)))))


;;;**************** EVAL - REPEAT *******************


(define (repeat? exp) (tagged-list? exp 'repeat))


(define (eval-repeat exp env)
(let ((sequenza (make-begin (cddr exp)))
     (counter (myeval (cadr exp) env)))
  (if (< counter 0) (error "Repeat - negative value for n!"))
  (repeat-iter sequenza counter env)))

        (define (repeat-iter what times env)
          (if (> (myeval times env) 0)
              (begin
              (myeval what env)
              (repeat-iter what (myeval (list '- times '1) env) env)
              )))
                                    


;;;**************** EVAL - IF ***********************

(define (if? exp) (tagged-list? exp 'if))

(define (if-predicate exp) (cadr exp))

(define (if-consequent exp) (caddr exp))

(define (if-alternative exp)
  (if (not (null? (cdddr exp)))
      (cadddr exp)
      'false))

(define (make-if predicate consequent alternative)
  (list 'if predicate consequent alternative))

;;;**************** EVAL - BEGIN ********************

(define (begin? exp) (tagged-list? exp 'begin))

(define (begin-actions exp) (cdr exp))

(define (last-exp? seq) (null? (cdr seq)))
(define (first-exp seq) (car seq))
(define (rest-exps seq) (cdr seq))

(define (sequence->exp seq)
  (cond ((null? seq) seq)
        ((last-exp? seq) (first-exp seq))
        (else (make-begin seq))))

(define (make-begin seq) (cons 'begin seq))

;;;**************** EVAL - COND *********************

(define (cond? exp) (tagged-list? exp 'cond))

(define (cond-clauses exp) (cdr exp))

(define (cond-else-clause? clause)
  (eq? (cond-predicate clause) 'else))

(define (cond-predicate clause) (car clause))

(define (cond-actions clause) (cdr clause))

(define (cond->if exp)
  (expand-clauses (cond-clauses exp)))

(define (expand-clauses clauses)
  (if (null? clauses)
      'false                          ; no else clause
      (let ((first (car clauses))
            (rest (cdr clauses)))
        (if (cond-else-clause? first)
            (if (null? rest)
                (sequence->exp (cond-actions first))
                (error "ELSE clause isn't last -- COND->IF"
                       clauses))
            (make-if (cond-predicate first)
                     (sequence->exp (cond-actions first))
                     (expand-clauses rest))))))


;;;**************** EVAL - LET **********************

(define (let? exp) (tagged-list? exp 'let))

(define (let->lambda exp)
  (let ((body (cddr exp))
        (parameters (map car (cadr exp)))
        (arguments (map cadr (cadr exp))))
    `((lambda ,parameters ,@body) ,@arguments)))

;;;**************** EVAL - LET* **********************

(define (let*? exp) (tagged-list? exp 'let*))

(define (let*->lets-nidificati exp)
  (define (let-rec head body)
      (if (not (null? head))
          (list 'let (list (car head))
                (let-rec (cdr head) body))
    body))
  (let-rec (cadr exp) (caddr exp)))


;;;**************** EVAL - ++ / -- ******************

; Incremento e decremento (++ variabile) (-- variabile) 
(define (?++ exp) (tagged-list? exp '++))

(define (++-eval exp env)
  (let ((val (lookup-variable-value (cadr exp) env)))
    (let ((result (+ 1 val)))
      (set-variable-value! (cadr exp) result env)
      result)))

(define (?-- exp) (tagged-list? exp '--))

(define (---eval exp env)
  (let ((val (lookup-variable-value (cadr exp) env)))
    (let ((result (- val 1)))
      (set-variable-value! (cadr exp) result env)
      result)))

;;;**************** EVAL - += / -= ******************

; Incremento (+= variabile)
(define (?+= exp) (tagged-list? exp '+=))

(define (+=-eval exp env)
  (let ((val (lookup-variable-value (cadr exp) env)))
    (let ((result (+ (caddr exp) val)))
      (set-variable-value! (cadr exp) result env)
      result)))

; Decremento (-= variabile)
(define (?-= exp) (tagged-list? exp '-=))

(define (-=-eval exp env)
  (let ((val (lookup-variable-value (cadr exp) env)))
    (let ((result (- val (caddr exp))))
      (set-variable-value! (cadr exp) result env)
      result)))

; Moltiplicazione (*= variabile)
(define (?*= exp) (tagged-list? exp '*=))

(define (*=-eval exp env)
  (let ((val (lookup-variable-value (cadr exp) env)))
    (let ((result (* val (caddr exp))))
      (set-variable-value! (cadr exp) result env)
      result)))

; Divisione (/= variabile)
(define (?/= exp) (tagged-list? exp '/=))

(define (/=-eval exp env)
  (let ((val (lookup-variable-value (cadr exp) env)))
    (let ((result (/ val (caddr exp))))
      (set-variable-value! (cadr exp) result env)
      result)))

;____________________________________________________


;====================================================
; MAKE PROCEDURE
;----------------------------------------------------

(define (make-procedure parameters body env)
  (list 'procedure parameters body env))

(define (compound-procedure? p)
  (tagged-list? p 'procedure))


(define (procedure-parameters p) (cadr p))
(define (procedure-body p) (caddr p))
(define (procedure-environment p) (cadddr p))
;____________________________________________________


;====================================================
; FUNZIONI PER STRUTTURA A FRAME E DEFINIZIONI
;----------------------------------------------------

(define (enclosing-environment env) (cdr env))

(define (first-frame env) (car env))

(define the-empty-environment '())

(define (make-frame variables values)
  (cons variables values))

(define (frame-variables frame) (car frame))
(define (frame-values frame) (cdr frame))

(define (add-binding-to-frame! var val frame)
  (set-car! frame (cons var (car frame)))
  (set-cdr! frame (cons val (cdr frame))))

(define (extend-environment vars vals base-env)
  (if (= (length vars) (length vals))
      (cons (make-frame vars vals) base-env)
      (if (< (length vars) (length vals))
          (error "Too many arguments supplied" vars vals)
          (error "Too few arguments supplied" vars vals))))

(define (lookup-variable-value var env)
  (define (env-loop env)
    (define (scan vars vals)
      (cond ((null? vars)
             (env-loop (enclosing-environment env)))
            ((eq? var (car vars))
             (car vals))
            (else (scan (cdr vars) (cdr vals)))))
    (if (eq? env the-empty-environment)
        (error "Unbound variable" var)
        (let ((frame (first-frame env)))
          (scan (frame-variables frame)
                (frame-values frame)))))
  (env-loop env))

(define (set-variable-value! var val env)
  (define (env-loop env)
    (define (scan vars vals)
      (cond ((null? vars)
             (env-loop (enclosing-environment env)))
            ((eq? var (car vars))
             (set-car! vals val))
            (else (scan (cdr vars) (cdr vals)))))
    (if (eq? env the-empty-environment)
        (error "Unbound variable -- SET!" var)
        (let ((frame (first-frame env)))
          (scan (frame-variables frame)
                (frame-values frame)))))
  (env-loop env))

(define (define-variable! var val env)
  (let ((frame (first-frame env)))
    (define (scan vars vals)
      (cond ((null? vars)
             (add-binding-to-frame! var val frame))
            ((eq? var (car vars))
             (set-car! vals val))
            (else (scan (cdr vars) (cdr vals)))))
    (scan (frame-variables frame)
          (frame-values frame))))

(define (setup-environment)
  (let ((initial-env
         (extend-environment (primitive-procedure-names)
                             (primitive-procedure-objects)
                             the-empty-environment)))
    (define-variable! 'true true initial-env)
    (define-variable! 'false false initial-env)
    initial-env))
;____________________________________________________


;====================================================
; LISTA PRIMITIVE + IMPLEMENTAZIONE
;----------------------------------------------------
(define (my-display what)
  (car (list what)))

(define (primitive-procedure? proc)
  (tagged-list? proc 'primitive))

(define (primitive-implementation proc) (cadr proc))

(define primitive-procedures
  (list (list 'car car)
        (list 'cdr cdr)
        (list 'cadr cadr)
        (list 'cddr cddr)
        (list 'caddr caddr)
        (list 'caar caar)
        (list 'error error)
        (list 'cons cons)
        (list 'null? null?)
        (list 'pair? pair?)
        (list 'set-car! set-car!)
        (list 'set-cdr! set-cdr!)
        (list 'list list)
        (list 'length length)
        (list 'list-tail list-tail)
        (list 'list-ref list-ref)
        (list 'append append)
        (list 'reverse reverse)
        (list 'memq memq)
        (list 'memv memv)
        (list 'member member)
        (list 'assq assq)
        (list 'assv assv)
        (list 'assoc assoc)
        (list 'not not)
        (list 'eq? eq?)
        (list 'eqv? eqv?)
        (list 'equal? equal?)
        (list 'symbol? symbol?)
        (list 'clearscreen clearscreen)
        (list 'max max)
        (list 'min min)
        (list 'positive? positive?)
        (list 'negative? negative?)
        (list 'number? number?)
        (list 'integer? integer?)
        (list 'rational? rational?)
        (list 'real? real?)
        (list 'complex? complex?)
        (list 'exact? exact?)
        (list 'inexact? inexact?)
        (list 'zero? zero?)
        (list 'even? even?)
        (list 'odd? odd?)
        (list 'modulo modulo)
        (list 'remainder remainder)
        (list 'quotient quotient)
        (list 'gcd gcd)
        (list 'lcm lcm)
        (list 'numerator numerator)
        (list 'denominator denominator)
        (list 'floor floor)
        (list 'ceiling ceiling)
        (list 'truncate truncate)
        (list 'round round)
        (list 'exp exp)
        (list 'log log)
        (list 'sqrt sqrt)
        (list 'expt expt)
        (list 'apply apply)
        (list 'abs abs)
        (list '+ +)
        (list '- -)
        (list '* *)
        (list '/ /)
        (list '= =)
        (list '> >)
        (list '< <)
        (list 'sin sin)
        (list 'cos cos)
        (list 'tan tan)
        (list 'asin asin)
        (list 'acos acos)
        (list 'atan atan)
        (list 'newline newline)
        (list '<= <=)
        (list '>= >=)
        (list 'atom? atom?)
        (list 'maketurtle maketurtle)
        (list 'showturtle showturtle)
        (list 'hideturtle hideturtle)
        (list 'forward forward)
        (list 'back back)
        (list 'right right)
        (list 'left left)
        (list 'pendown pendown)
        (list 'penup penup)
        (list 'info info)
        (list 'setpos setpos)
        (list 'setangle setangle)
        (list 'pushturtle pushturtle)
        (list 'popturtle popturtle)
        (list 'setpencolor setpencolor)
        (list 'setpenwidth setpenwidth)
        (list 'setpenstyle setpenstyle)
        (list 'display print-to-transcript)
        (list 'gohome gohome)
        (list 'draw-text my-draw-text)
        ))



(define (primitive-procedure-names)
  (map car
       primitive-procedures))

(define (primitive-procedure-objects)
  (map (lambda (proc) (list 'primitive (cadr proc)))
       primitive-procedures))

(define (apply-primitive-procedure proc args)
  (apply-in-underlying-scheme
   (primitive-implementation proc) args))
;____________________________________________________

; METAEVALUATOR V.90 - CODENAME: 'The Lizard King'



